//+------------------------------------------------------------------+
//|                                                #fct_MTFHiLo_V1.0 |                                                            
//+------------------------------------------------------------------+

//2013 - DEC - 02
//Coded by forexcodetrader@gmail.com

#property indicator_chart_window

extern bool       ShowPreviousDaily = false;
extern color      PDailyColor = DeepPink;
extern int        PDailyStyle = 1;
extern int        PDailyWidth = 0;
extern int        PDailyShift = 4;

extern bool       ShowPreviousWeekly = true;
extern color      PWeeklyColor = WhiteSmoke;
extern int        PWeeklyStyle = 2;
extern int        PWeeklyWidth = 0;
extern int        PWeeklyShift = 2;

extern bool       ShowPreviousMonthly = true;
extern color      PMonthlyColor = LightGray;
extern int        PMonthlyStyle = 1;
extern int        PMonthlyWidth = 0;
extern int        PMonthlyShift = 0;

string LineHearder = "fctHiLo_";
int NewBarTF0 = 0;

int D1StartTime, D1EndTime, W1StartTime, W1EndTime, MN1StartTime, MN1EndTime;

//=========================================

int init()
{
   IndicatorShortName("fctHiLo_V1.0");  
   return(0);
}

//=========================================
   
int deinit()
{
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
      if (StringFind(ObjectName(i), LineHearder) >= 0) ObjectDelete(ObjectName(i));
   return(0);
}

int start()
{
   if(!isNewBar()) return;
   if(ShowPreviousDaily) fnDrawD1HLAll();
   if(ShowPreviousWeekly) fnDrawW1HLAll();
   if(ShowPreviousMonthly) fnDrawMN1HLAll();
}

//=========================================

void fnDrawD1HLAll()
{
   if(Period() > PERIOD_H4) return;
   int startTFTime = iTime(Symbol(), Period(), iBars(Symbol(), Period()) - 1);
   int startD1ShiftLimit = iBarShift(Symbol(), PERIOD_D1, startTFTime, false);
   for(int i = 0; i < startD1ShiftLimit; i++)
   {   
     fnDrawD1HL(i);
   }   
}

void fnDrawD1HL (int iShift)
{
   double HighVal, LowVal;
   D1StartTime = iTime(Symbol(), PERIOD_D1, iShift);
   if(TimeDayOfWeek(D1StartTime) == 0) return;
   if(TimeDayOfWeek(D1StartTime) == 1 && TimeDayOfWeek(iTime(Symbol(), PERIOD_D1, iShift + 1)) == 0)
   {
      HighVal = MathMax(iHigh(Symbol(), PERIOD_D1, iShift + 1), iHigh(Symbol(), PERIOD_D1, iShift + 2));
      LowVal  = MathMin(iLow(Symbol(), PERIOD_D1, iShift + 1), iLow(Symbol(), PERIOD_D1, iShift + 2));
   }
   else
   {
      HighVal = iHigh(Symbol(), PERIOD_D1, iShift + 1);
      LowVal = iLow(Symbol(), PERIOD_D1, iShift + 1);
   }
   
   if(iShift != 0) D1EndTime   = iTime(Symbol(), PERIOD_D1, iShift - 1);
   else D1EndTime   = iTime(Symbol(), Period(), 0) + PDailyShift*60*Period();
   
   fnPlotLine(LineHearder +"Daily-Hi_" + D1StartTime, HighVal, D1StartTime, D1EndTime, PDailyStyle, PDailyWidth, PDailyColor);
   fnPlotLine(LineHearder +"Daily-Lo_" + D1StartTime, LowVal, D1StartTime, D1EndTime, PDailyStyle, PDailyWidth, PDailyColor);
}
   
//=========================================

void fnDrawW1HLAll()
{
   if(Period() >= PERIOD_W1) return(0);
   int startTFTime = iTime(Symbol(), Period(), iBars(Symbol(), Period()) - 1);
   int startW1ShiftLimit = iBarShift(Symbol(), PERIOD_W1, startTFTime, false);

   for(int i = 0; i < startW1ShiftLimit; i++)
   {   
     fnDrawW1HL(i);
   }   
}

void fnDrawW1HL (int iShift)
{   
   double HighVal, LowVal;
   
   W1StartTime = iTime(Symbol(), PERIOD_W1, iShift);
   if(TimeDayOfWeek(W1StartTime) == 0) {W1StartTime = incDateTradeDay(W1StartTime);}
   if(iShift != 0)
   {
      W1EndTime   = iTime(Symbol(), PERIOD_W1, iShift - 1);
      if(TimeDayOfWeek(W1EndTime) == 0) {W1EndTime = incDateTradeDay(W1EndTime);}
   }
   else W1EndTime = iTime(Symbol(), Period(), 0) + PWeeklyShift*60*Period();

   HighVal = iHigh(Symbol(), PERIOD_W1, iShift + 1);
   LowVal = iLow(Symbol(), PERIOD_W1, iShift + 1);

   fnPlotLine(LineHearder +"Weekly-Hi_" + W1StartTime, HighVal, W1StartTime, W1EndTime, PWeeklyStyle, PWeeklyWidth, PWeeklyColor);
   fnPlotLine(LineHearder +"Weekly-Lo_" + W1StartTime, LowVal, W1StartTime, W1EndTime, PWeeklyStyle, PWeeklyWidth, PWeeklyColor);
}
   
//=======================================

void fnDrawMN1HLAll()
{
   if(Period() >= PERIOD_MN1) return(0);
   int startTFTime = iTime(Symbol(), Period(), iBars(Symbol(), Period()) - 1);
   int startMN1ShiftLimit = iBarShift(Symbol(), PERIOD_MN1, startTFTime, false);

   for(int i = 0; i < startMN1ShiftLimit; i++)
   {   
     fnDrawMN1HL(i);
   }   
}

void fnDrawMN1HL (int iShift)
{
   double HighVal, LowVal;
   int l_Shift, l_ShiftA, cTFTime;
   
   MN1StartTime = iTime(Symbol(), PERIOD_MN1, iShift);   
   l_Shift = iBarShift(Symbol(), Period(), MN1StartTime, false);
   cTFTime = iTime(Symbol(), Period(), l_Shift);
   l_ShiftA = iBarShift(Symbol(), Period(), cTFTime, false);
   if(TimeMonth(MN1StartTime) <= TimeMonth(cTFTime))
   {
      while(TimeMonth(Time[l_ShiftA]) == TimeMonth(Time[l_ShiftA + 1]))
      {
         l_ShiftA ++;
      }
      MN1StartTime = Time[l_ShiftA];
   }
   else
   {      
      while(TimeMonth(Time[l_ShiftA]) == TimeMonth(Time[l_ShiftA - 1]))
      {
         l_ShiftA --;         
      }
      l_ShiftA --;
      MN1StartTime = Time[l_ShiftA];
   }
   //  
   if(iShift != 0)
   {
      MN1EndTime = iTime(Symbol(), PERIOD_MN1, iShift - 1);
      l_Shift = iBarShift(Symbol(), Period(), MN1EndTime, false);
      cTFTime = iTime(Symbol(), Period(), l_Shift);   
      l_ShiftA = iBarShift(Symbol(), Period(), cTFTime, false);
      if(TimeMonth(MN1EndTime) <= TimeMonth(cTFTime))
      {
         while(TimeMonth(Time[l_ShiftA]) == TimeMonth(Time[l_ShiftA + 1]))
         {
            l_ShiftA ++;
         }
         MN1EndTime = Time[l_ShiftA];
      }
      else
      {
         while(TimeMonth(Time[l_ShiftA]) == TimeMonth(Time[l_ShiftA - 1]))
         {
            l_ShiftA --;         
         }
         l_ShiftA --;
         MN1EndTime = Time[l_ShiftA];
      }      
   }
   else MN1EndTime = iTime(Symbol(), Period(), 0) + PMonthlyShift*60*Period();

   HighVal = iHigh(Symbol(), PERIOD_MN1, iShift + 1);
   LowVal = iLow(Symbol(), PERIOD_MN1, iShift + 1);   
   fnPlotLine(LineHearder +"Monthly-Hi_" + MN1StartTime, HighVal, MN1StartTime, MN1EndTime, PMonthlyStyle, PMonthlyWidth, PMonthlyColor);
   fnPlotLine(LineHearder +"Monthly-Lo_" + MN1StartTime, LowVal,  MN1StartTime, MN1EndTime, PMonthlyStyle, PMonthlyWidth, PMonthlyColor);
}
   
//=======================================

datetime incDateTradeDay (datetime dt)
{
   int ty=TimeYear(dt);
   int tm=TimeMonth(dt);
   int td=TimeDay(dt);
   int th=TimeHour(dt);
   int ti=TimeMinute(dt);

   td++;
   if(tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10)
   {
      if(td == 32) {td = 1; tm++;}
   }
   if(tm==12)
   {
      if(td == 32) {td = 1; tm = 1; ty++;}
   }
   if (tm==4 || tm==6 || tm==9 || tm==11)
   {
      if(td == 31) {td = 1; tm++;}
   }
   if (tm==2)
   {
      if(MathMod(ty, 4) == 0)
      {
         if(td == 30) {td = 1; tm++;}
      }
      else
      {
         if(td == 29) {td = 1; tm++;}
      }
   }
     
   return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}

//=========================================

void fnPlotLine(string iName, double iVal, int iTime1, int iTime2, double iStyle, int iWidth, color iColor)
{
   ObjectCreate(iName, OBJ_TREND, 0, iTime1, iVal, iTime2, iVal);
   ObjectSet(iName, OBJPROP_WIDTH, iWidth);
   ObjectSet(iName, OBJPROP_STYLE, iStyle);
   ObjectSet(iName, OBJPROP_COLOR, iColor);
   ObjectSet(iName, OBJPROP_RAY, false);
} 
//=========================================

bool isNewBar()
{   
   bool NewBar = false;
   if (NewBarTF0 != iTime(Symbol(), Period(), 0))
   {
      NewBarTF0 = iTime(Symbol(), Period(), 0);
      NewBar = true;
   }  
   return (NewBar);
}